Gecode::BoolExpr Class Reference

Boolean expressions. More...

`#include <minimodel.hh>`

## Classes

class | Misc
| Miscealloneous Boolean expressions. More...
class | Node
| Node for Boolean expression More...

## Public Types

enum | NodeType { NT_VAR , NT_NOT , NT_AND , NT_OR , NT_EQV , NT_RLIN , NT_RLINFLOAT , NT_RSET , NT_MISC }
| Type of Boolean expression. More...

## Public Member Functions

| BoolExpr (void)
| Default constructor.
| BoolExpr (const BoolExpr &e)
| Copy constructor.
| BoolExpr (const BoolExpr &l, NodeType t, const BoolExpr &r)
| Construct expression for type and subexpresssions.
| BoolExpr (const BoolVar &x)
| Construct expression for variable.
| BoolExpr (const BoolExpr &e, NodeType t)
| Construct expression for negation.
| BoolExpr (const LinIntRel &rl)
| Construct expression for reified linear relation.
| BoolExpr (const LinFloatRel &rfl)
| Construct expression for reified float relation.
| BoolExpr (const SetRel &rs)
| Construct expression for reified set relation.
| BoolExpr (const SetCmpRel &rs)
| Construct expression for reified set relation.
| BoolExpr (Misc *m)
| Construct expression for miscellaneous Boolean expression.
BoolVar | expr (Home home, const IntPropLevels &ipls) const
| Post propagators for expression.
void | rel (Home home, const IntPropLevels &ipls) const
| Post propagators for relation.
const BoolExpr & | operator= (const BoolExpr &e)
| Assignment operator.
| ~BoolExpr (void)
| Destructor.

## Detailed Description

Boolean expressions.

Definition at line 1329 of file minimodel.hh.

## Member Enumeration Documentation

## NodeType

enum Gecode::BoolExpr::NodeType

Type of Boolean expression.

Enumerator
NT_VAR | Variable.
NT_NOT | Negation.
NT_AND | Conjunction.
NT_OR | Disjunction.
NT_EQV | Equivalence.
NT_RLIN | Reified linear relation.
NT_RLINFLOAT | Reified linear relation.
NT_RSET | Reified set relation.
NT_MISC | Other Boolean expression.

Definition at line 1332 of file minimodel.hh.

## Constructor & Destructor Documentation

## BoolExpr() [1/10]

Gecode::BoolExpr::BoolExpr | ( | void |  | ) |

Default constructor.

Definition at line 114 of file bool-expr.cpp.

## BoolExpr() [2/10]

Gecode::BoolExpr::BoolExpr | ( | const BoolExpr & | e | ) |

Copy constructor.

Definition at line 116 of file bool-expr.cpp.

## BoolExpr() [3/10]

Gecode::BoolExpr::BoolExpr | ( | const BoolExpr & | l,
|  | NodeType | t,
|  | const BoolExpr & | r )

Construct expression for type and subexpresssions.

Definition at line 128 of file bool-expr.cpp.

## BoolExpr() [4/10]

Gecode::BoolExpr::BoolExpr | ( | const BoolVar & | x | ) |

Construct expression for variable.

Definition at line 120 of file bool-expr.cpp.

## BoolExpr() [5/10]

Gecode::BoolExpr::BoolExpr | ( | const BoolExpr & | e,
|  | NodeType | t )

Construct expression for negation.

Definition at line 140 of file bool-expr.cpp.

## BoolExpr() [6/10]

Gecode::BoolExpr::BoolExpr | ( | const LinIntRel & | rl | ) |

Construct expression for reified linear relation.

Definition at line 156 of file bool-expr.cpp.

## BoolExpr() [7/10]

Gecode::BoolExpr::BoolExpr | ( | const LinFloatRel & | rfl | ) |

Construct expression for reified float relation.

Definition at line 166 of file bool-expr.cpp.

## BoolExpr() [8/10]

Gecode::BoolExpr::BoolExpr | ( | const SetRel & | rs | ) |

Construct expression for reified set relation.

Definition at line 177 of file bool-expr.cpp.

## BoolExpr() [9/10]

Gecode::BoolExpr::BoolExpr | ( | const SetCmpRel & | rs | ) |

Construct expression for reified set relation.

Definition at line 186 of file bool-expr.cpp.

## BoolExpr() [10/10]

Gecode::BoolExpr::BoolExpr | ( | BoolExpr::Misc * | m | ) |

explicit

Construct expression for miscellaneous Boolean expression.

Definition at line 196 of file bool-expr.cpp.

## ~BoolExpr()

Gecode::BoolExpr::~BoolExpr | ( | void |  | ) |

Destructor.

Definition at line 218 of file bool-expr.cpp.

## Member Function Documentation

## expr()

BoolVar Gecode::BoolExpr::expr | ( | Home | home,
|  | const IntPropLevels & | ipls ) const

Post propagators for expression.

Definition at line 574 of file bool-expr.cpp.

## rel()

void Gecode::BoolExpr::rel | ( | Home | home,
|  | const IntPropLevels & | ipls ) const

Post propagators for relation.

Definition at line 580 of file bool-expr.cpp.

## operator=()

const BoolExpr & Gecode::BoolExpr::operator= | ( | const BoolExpr & | e | ) |

Assignment operator.

Definition at line 206 of file bool-expr.cpp.

The documentation for this class was generated from the following files:

- gecode/minimodel.hh
- gecode/minimodel/bool-expr.cpp